<template>
  <div>
    <div
      v-if="loading"
      class="d-flex justify-center align-center flex-column"
      style="height: 100%"
    >
      <v-progress-circular
        indeterminate
        class="d-block text-center"
        color="#7319D5"
        size="60"
        width="6"
      />
      <div class="mt-4 loading-text text-center">Cargando resultados....</div>
    </div>
    <v-container v-else fluid class="pa-0">
      <v-row class="ma-0" justify="center" v-if="this.getPercentage == 100">
        <v-col
          md="6"
          cols="12"
          class="pa-0 ma-0"
          style="max-width: 1000px"
          align="center"
        >
          <v-card class="px-4 py-5">
            <div class="mb-8 tway-headline-2 tway-gray-dark--text">
              ¡Has completado con éxito la encuesta Tway! Tu Índice de Madurez
              en Transformación Digital es:
            </div>
            <v-progress-circular
              :rotate="-90"
              :size="172"
              :width="20"
              :value="percentage.value"
              color="#16C62E"
            >
              <span class="roboto pertentage-text"
                >{{ percentage.value }}%</span
              >
            </v-progress-circular>

            <v-row justify="center" align="center" class="mt-5">
              <span class="title-idx-subtitle" v-if="percentage.index">
                <span v-if="dti.score * 10 <= 40">Nivel Básico</span>
                <span v-if="dti.score * 10 > 40 && dti.score * 10 <= 60"
                  >Nivel Inicial</span
                >
                <span v-if="dti.score * 10 > 60 && dti.score * 10 <= 80"
                  >Nivel Estratégico</span
                >
                <span v-if="dti.score * 10 > 80">Nivel competitivo</span>
              </span>
            </v-row>
            <v-row
              justify="start"
              align="center"
              class="mt-4 px-5 pt-0 d-block"
            >
              <div class="roboto body-idx-text mt-3">
                <div
                  style="white-space: pre-wrap; word-wrap: break-word"
                  v-if="dti.score * 10 <= 40"
                >
                  {{ levels[0] }}
                </div>
                <div
                  style="white-space: pre-wrap; word-wrap: break-word"
                  v-if="dti.score * 10 > 40 && dti.score * 10 <= 60"
                >
                  {{ levels[1] }}
                </div>
                <div
                  style="white-space: pre-wrap; word-wrap: break-word"
                  v-if="dti.score * 10 > 60 && dti.score * 10 <= 80"
                >
                  {{ levels[2] }}
                </div>
                <div
                  style="white-space: pre-wrap; word-wrap: break-word"
                  v-if="dti.score * 10 > 80"
                >
                  {{ levels[3] }}
                </div>
              </div>
              <div class="roboto body-idx-text mt-5">
                Puedes ver la descripción completa en la página de inicio.
              </div>
              <div class="text-left mt-5" style="font-weight: 700">
                ¡Aún hay más!
              </div>
              <div class="roboto body-idx-text mt-3">
                Obtén tu diagnóstico de Madurez en Transformación Digital con el
                detalle de cada dimensión al suscribirte a nuestros planes. Al
                hacerlo, activarás tu dashboard personalizado con:
                <ul class="mt-2 ml-5">
                  <li>
                    Información detallada sobre tus brechas digitales y desafíos
                    críticos
                  </li>
                  <li>
                    Plan de trabajo para acelerar la transformación digital de
                    tu empresa
                  </li>
                  <li>
                    Soluciones y servicios a la medida de tus necesidades de
                    transformación
                  </li>
                </ul>
              </div>
              <div class="d-flex justify-center mb-5">
                <v-btn
                  rounded
                  color="#16C62E"
                  class="button-text white--text mt-5"
                  :to="{ name: 'plans' }"
                >
                  ¡ver planes!
                </v-btn>
              </div>
            </v-row>
          </v-card>
          <div class="mb-8 tway-headline-2 tway-gray-dark--text text-left mt-9">
            Recuerda que también puedes continuar con los siguientes pasos:
          </div>

          <UserSteps />

          <div class="d-flex justify-center">
            <v-btn
              depressed
              rounded
              color="transparent"
              class="button-text tway-violet--text mt-11 mb-10"
              :to="{ name: 'home' }"
              v-if="this.getPercentage == 100 && desktop"
            >
              volver al inicio
            </v-btn>
          </div>
        </v-col>
      </v-row>
      <v-row
        class="ma-0"
        :class="desktop ? 'pt-16' : ''"
        justify="center"
        v-else
      >
        <v-col class="pa-0 ma-0" style="max-width: 1000px" align="center">
          <v-img
            :src="require('@/assets/img/encuesta.svg')"
            class="rounded mb-8"
            contain
            max-width="450px"
          />
          <div
            style="font-size: 25px"
            class="mb-8 mt-4 form-title tway-gray-dark--text"
          >
            Diagnóstico de Transformación Digital
          </div>
          <div class="tway-header-2 tway-gray-dark--text mb-4">
            Para activar, acelerar y facilitar la Transformación, el primer paso
            es diagnosticar el status digital de tu compañía. Aquí comienza el
            proceso que recalibra tu negocio y ajusta su propuesta de valor a
            las exigencias de la Industria 4.0.
          </div>
          <div class="tway-header-2 tway-gray-dark--text mb-4">
            Con este Índice, inicias el camino hacia la competitividad necesaria
            en la Economía Digital.
          </div>
          <div class="tway-header-2 tway-gray-dark--text mb-12">
            No tardarás más de 15 minutos.
          </div>
          <v-row class="ma-0" justify="center">
            <v-btn
              depressed
              rounded
              color="tway-violet"
              class="button-text white--text"
              :to="{ name: 'survey' }"
              v-if="this.getPercentage != 100"
            >
              <span v-if="this.getPercentage == 0">Completar encuesta</span>
              <span v-else>Continuar encuesta</span>
            </v-btn>
          </v-row>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
import CompanyService from "@/services/companyService";
import dtService from "@/services/dtService";
import currentUserService from "@/services/currentUserService";
import UserSteps from "@/components/UserSteps.vue";
import { mapActions, mapGetters } from "vuex";

export default {
  components: { UserSteps },
  name: "Form",

  data: () => ({
    clientType: "",
    firstDti: false,
    percentage: {
      value: 0,
      index: true,
    },
    dti: {
      score: 0,
    },
    levels: [
      "La empresa enfrenta el futuro con mentalidad mayoritariamente analógica, sin plan digital. Suma innovaciones aisladas. Opera con sistemas rígidos y poco eficientes para adaptarse a los intereses de los clientes y del mercado. Aspira a incorporar la Transformación Digital, pero las decisiones son tardías y lentas. Falta un liderazgo que impulse el proceso de transformación. Aparecen resistencias. La organización persiste en hacer las cosas como hasta ahora, sin integrar competencias digitales. La organización está enfocada en una rentabilidad de corto plazo. Su competitividad futura es baja.",
      "La empresa integra innovaciones en procesos específicos para bajar costos y aumentar margen. Resuelve problemas actuales con tecnologías, más que cambiar la forma de hacer las cosas. Pone en marca acciones digitales, sin claridad sobre el valor que tendrán en el negocio futuro.",
      "La empresa alinea su propósito a la Transformación Digital como estrategia de negocio.",
      "La estrategia, proyecto y gestión de Transformación Digital es central y transversal. Completamente integrada al negocio, busca crear ventajas competitivas a largo plazo en contextos dinámicos. La tecnología es su aliado en la nube.",
    ],
    loading: true,
  }),

  async created() {
    this.firstDti = this.$route.params.firstDti;

    this.user = await currentUserService.currentUserData();

    const questions = await dtService.getSurveyComplete("a123", this.user.id);

    this.SET_PERCENTAGE(
      Math.floor((questions.answered / questions.total) * 100)
    );

    if (this.getPercentage != 100) {
      this.loading = false;
    } else {
      this.getDti(this.user.id, questions.surveyId);
    }
  },
  methods: {
    ...mapActions("UserStore", ["SET_PERCENTAGE"]),
    async getCompany() {
      this.clientType = await CompanyService.getCompanyProfile().type;
    },
    async getDti(userId, surveyId) {
      this.dti = await dtService.getDti(userId, surveyId, this.firstDti);
      this.percentage.value = (this.dti.score * 10).toFixed(0);
      this.loading = false;
    },
    goTo(to) {
      this.$router.push(to);
    },
  },
  computed: {
    ...mapGetters("UserStore", ["getPercentage"]),
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },
};
</script>

<style lang="scss" scoped>
.form-title {
  font-weight: 400 !important;
}
.tway-header-2 {
  font-weight: 300 !important;
  font-size: 16px;
  line-height: 25px !important;
  font-family: "Roboto Condensed", sans-serif !important;
}
.title-idx-subtitle {
  font-size: 25px;
  line-height: 30px;
  font-weight: 700;
  text-align: start;
  color: #7319d5;
}
.body-idx-text {
  font-size: 16px;
  line-height: 24px;
  font-weight: 400;
  text-align: start;
  color: rgba(#000, 0.8);
}
.step-text {
  max-width: 36em;
}
.loading-text {
  font-family: Roboto Condensed;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 24px;
  color: #333333;
}
.pertentage-text {
  font-family: Roboto;
  font-style: normal;
  font-weight: bold;
  font-size: 36px;
  line-height: 42px;
  text-align: center;
  text-transform: uppercase;
  color: #7319d5;
}
</style>
